<template>
  <div id="chapterVolumeManagementAdd">
    <el-form
      label-position="right"
      label-width="120px"
      :model="listData"
      :rules="rules"
      ref="listData"
    >
      <div class="boxWidth">
        <el-form-item label="适用业务层级" :required="true">
          <el-select
            v-model="eduType"
            placeholder="请选择教育类型"
            @change="changeEduType"
          >
            <el-option
              v-for="(item, index) in eduTypeOptions"
              :key="index"
              :label="item.educationName"
              :value="item.id"
            >
            </el-option>
          </el-select>
          <el-select
            v-model="courType"
            placeholder="请选择业务层次"
            @change="changecourseType"
          >
            <el-option
              v-for="(item, index) in newCourTypeOptions"
              :key="index"
              :label="item.projectName + '-' + item.businessName"
              :value="item.id"
            >
            </el-option>
          </el-select>
          <el-popover
            ref="popovers"
            placement="bottom"
            trigger="click"
            @show="showHandle"
            @hide="hideHandle"
            :disabled="courType ? false : true"
          >
            <el-radio-group v-model="sujectApis" class="dis_flexbox">
              <el-radio
                v-for="(item, index) in newSujectOption"
                :label="item.newId"
                :key="index"
                >{{ item.subjectName }}</el-radio
              >
            </el-radio-group>
            <div style="display: block; text-align: center; margin-top: 10px">
              <el-button size="mini" type="primary" @click="submitSujectArray"
                >关闭</el-button
              >
            </div>
            <el-button
              slot="reference"
              style="margin-left: 12px"
              @click="getMessage"
              >请选择科目</el-button
            >
          </el-popover>
        </el-form-item>
        <el-form-item label="">
          <!-- <span v-if="Object.keys(newSujectApis).length == 0"
            >未选项目类型</span
          > -->
          <div
            v-if="Object.keys(newSujectApis).length !== 0"
            style="display: flex"
          >
            <div class="listBoxStys">
              {{
                newSujectApis.educationName +
                " - " +
                newSujectApis.projectName +
                " - " +
                newSujectApis.businessName +
                " - " +
                newSujectApis.subjectName
              }}
              <i class="el-icon-error closeIcons" @click="closeType"></i>
            </div>
          </div>
          <el-popover
            placement="bottom-start"
            trigger="hover"
            :close-delay="50"
          >
            <ul style="margin: 0; max-width: 600px">
              <li
                class="copyDataLi"
                :class="changeSty(itemT)"
                v-for="(itemT, indexT) in localData"
                :key="indexT"
                @click="unTime(itemT)"
              >
                {{
                  `${itemT.educationName}-${itemT.projectName}-${itemT.businessName}-${itemT.subjectName}`
                }}
              </li>
            </ul>
            <el-button
              v-show="localData.length"
              type="danger"
              slot="reference"
              size="mini"
              style="margin-right: 10px"
              >最近选择</el-button
            >
          </el-popover>
        </el-form-item>
        <el-form-item label="标题前缀" prop="prefixName">
          <el-input v-model="listData.prefixName"></el-input>
        </el-form-item>
        <el-form-item label="章卷名称" prop="name">
          <el-input v-model="listData.name"></el-input>
        </el-form-item>
        <el-form-item label="是否发布" prop="publishStatus">
          <el-radio-group v-model="listData.publishStatus">
            <el-radio :label="1">是</el-radio>
            <el-radio :label="0">否</el-radio>
          </el-radio-group>
        </el-form-item>
      </div>
      <el-form-item label="管理试卷">
        <div class="dis_plays">
          <div>
            <el-button size="small" @click="openBoxs">调用已有数据</el-button>
            <el-button size="small" @click="addChapter"
              >自定义添加试卷</el-button
            >
          </div>
          <div style="color: #f56c6c">
            <span style="margin-right: 10px"
              >试卷总数：{{ tableData.length }}</span
            >
            <!-- <span>总时长：{{ minTimeAll }}分钟</span> -->
          </div>
        </div>
        <el-table
          :data="tableData"
          border
          :header-cell-style="{
            'background-color': '#eee',
            padding: '8px',
            color: '#333',
          }"
          :default-sort="{ prop: 'sort', order: 'ascending' }"
        >
          <el-table-column
            v-for="(item, index) in tableSet"
            :width="item.width"
            :key="index"
            :label="item.label"
            align="center"
            :show-overflow-tooltip="true"
            header-align="center"
            :sortable="item.prop === 'sort'"
            sort-by="sort"
            :prop="item.prop"
          >
            <template slot-scope="scope">
              <span v-if="item.scope === 'types'">{{
                scope.row[item.prop] === 1
                  ? "录播"
                  : scope.row[item.prop] === 2
                  ? "直播"
                  : scope.row[item.prop] === 3
                  ? "回放"
                  : "未知"
              }}</span>
              <span v-else-if="item.scope === 'Status'">
                {{
                  scope.row[item.prop] === 1
                    ? "发布"
                    : scope.row[item.prop] === 0
                    ? "未发布"
                    : "未知"
                }}
              </span>
              <div v-else-if="item.scope === 'inputs'">
                <el-input-number
                  style="width: 50px"
                  size="small"
                  :controls="false"
                  v-model="scope.row[item.prop]"
                  controls-position="right"
                  :min="0"
                ></el-input-number>
              </div>
              <span v-else>{{ scope.row[item.prop] }}</span></template
            >
          </el-table-column>
          <el-table-column
            label="操作"
            align="center"
            fixed="right"
            width="180px"
          >
            <template slot-scope="scope">
              <el-button type="text" @click="jumpChapter(scope.row)"
                >试卷内容</el-button
              >
              <el-button type="text" @click="delList(scope.row, scope.$index)"
                >删除</el-button
              >
            </template>
          </el-table-column>
        </el-table>
      </el-form-item>
      <el-form-item>
        <el-button @click="backPage">取消</el-button>
        <el-button
          type="primary"
          @click="submitIns('listData')"
          :loading="disabledBtn"
          >确定</el-button
        >
      </el-form-item>
    </el-form>
    <el-dialog
      @closed="closedFunc"
      :visible.sync="dialogVisible"
      width="800px"
      :show-close="false"
      :close-on-click-modal="false"
    >
      <div slot="title" class="hearders">
        <div class="leftTitle">添加试卷</div>
        <div class="rightBoxs">
          <img
            src="@/assets/images/Close@2x.png"
            alt=""
            @click="dialogVisible = false"
          />
        </div>
      </div>
      <search-box-new
        ref="searchBox"
        :formData="formData"
        :formList="formList"
        @search="getInfos"
        @init="init"
      />
      <el-table
        ref="multipleTable"
        :data="boxtableData"
        border
        @select-all="selectAll"
        @select="select"
        :row-key="getRowKeys"
        :header-cell-style="{
          'background-color': '#eee',
          padding: '8px',
          color: '#333',
        }"
      >
        <el-table-column
          align="center"
          type="selection"
          width="55"
          header-align="center"
          :selectable="checkboxT"
          :reserve-selection="true"
        >
        </el-table-column>
        <template v-for="(item, index) in tableSet">
          <el-table-column
            v-if="item.scope !== 'inputs'"
            :width="item.width"
            :key="index"
            :label="item.label"
            align="center"
            :show-overflow-tooltip="true"
            header-align="center"
          >
            <template slot-scope="scope">
              <span v-if="item.scope === 'types'">{{
                scope.row[item.prop] === 1
                  ? "录播"
                  : scope.row[item.prop] === 2
                  ? "直播"
                  : scope.row[item.prop] === 3
                  ? "回放"
                  : "未知"
              }}</span>
              <span v-else-if="item.scope === 'Status'">
                {{
                  scope.row[item.prop] === 1
                    ? "发布"
                    : scope.row[item.prop] === 0
                    ? "未发布"
                    : "未知"
                }}
              </span>
              <span v-else>{{ scope.row[item.prop] }}</span></template
            >
          </el-table-column></template
        >
      </el-table>
      <pagination
        :total="total"
        :pageSize="formData.pageSize"
        :currentPage="formData.pageNum"
        @handleSizeChange="handleSizeChange"
        @handleCurrentChange="handleCurrentChange"
      />
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button
          type="primary"
          :disabled="activeLists.length === 0"
          @click="submitForm"
          >确 定</el-button
        >
      </span>
    </el-dialog>
    <addChapterjs ref="addChapterjs" @backData="backData" />
  </div>
</template>

<script>
import searchBoxNew from "@/components/searchBoxNew";
import pagination from "@/components/pagination";
import tableList from "@/components/tableList";
import addChapterjs from "../addChapterjs.vue";
export default {
  name: "ChapterVolumeManagementAdd",
  components: { searchBoxNew, tableList, pagination, addChapterjs },
  data() {
    return {
      disabledBtn: false,
      listData: {
        publishStatus: 1,
      }, //   弹窗数据
      eduTypeOptions: [], //教育类型数据
      projectTypeOptions: [], //项目类型数据
      courTypeOptions: [], //业务层次数据
      newCourTypeOptions: [], //当前业务层次数据
      sujectOption: [], //科目数据
      newSujectOption: [], //当前科目数据数据
      eduType: "", //当前选中教育类型
      courType: "", //当前选中业务层次

      newSujectApis: {},
      sujectApis: "", //当前存在的科目 例如'19-2'
      //表单验证
      rules: {
        name: [{ required: true, message: "请输入章卷名称", trigger: "blur" }],
        publishStatus: [
          { required: true, message: "请选择是否发布", trigger: "change" },
        ],
      },

      numberAll: 0, //试卷总数
      minTimeAll: 0, //总时长
      tableSet: [
        { label: "排序", prop: "sort", scope: "inputs", width: "100" },
        { label: "试卷编码", prop: "code", width: "140" },
        { label: "标题前缀", prop: "prefixName", width: "170" },
        { label: "试卷标题", prop: "examName" },
        { label: "题数量", prop: "questionNum", width: "120" },
        {
          label: "发布状态",
          prop: "publishStatus",
          scope: "Status",
          width: "120",
        },
      ],
      tableData: [],
      dialogVisible: false,
      boxtableData: [],
      total: 0, //一共多少条
      formData: {
        publishStatus: 1,
        status: 1,
        pageSize: 10,
        pageNum: 1,
      },
      //搜索
      formList: [
        // {
        //   prop: "educationTypeId",
        //   placeholder: "教育类型",
        //   scope: "educationType",
        // },
        // {
        //   prop: "businessId",
        //   placeholder: "业务层次",
        //   scope: "businessLevel",
        //   edu: "educationTypeId",
        // },
        {
          prop: "key",
          placeholder: "试卷标题/试卷编码/标题前缀",
        },
      ],
      disCheckList: [], //已选转禁用复选列表
      activeLists: [],
      localData: [],
    };
  },
  watch: {
    sujectApis: {
      immediate: true,
      handler(newName, oldName) {
        this.changeTypes();
      },
    },
    newSujectApis() {
      this.tableData = [];
    },
  },
  mounted() {
    this.localData = this.$methodsTools.getBusinessList();
    this.getDict();
    // this.search();
  },
  activated() {
    if (this.$store.getters.testPaperPage) {
      this.$api
        .obtainbankexam(this.$store.getters.testPaperPage.id)
        .then((res) => {
          const FIND = this.tableData.findIndex((item) => {
            return item.examId == this.$store.getters.testPaperPage.id;
          });
          if (FIND !== -1) {
            res.data.sort = this.tableData[FIND].sort;
            this.tableData.splice(FIND, 1, res.data);
          }
          this.$store.dispatch("changetestPaperPage", null);
        });
    }
  },
  methods: {
    jumpChapter(v) {
      const jump = () => {
        this.$store.dispatch("changetestPaperPage", {
          name: "chapterVolumeManagementAdd",
          id: v.examId,
        });
        this.$router.push({
          path: "editPaper",
          query: {
            id: v.examId,
            code: v.code,
            name: 1,
          },
        });
      };
      const statusPage = this.$store.state.tagsView.visitedViews.some(
        (item) => {
          return item.name == "EditPaper";
        }
      );
      if (statusPage) {
        this.$store
          .dispatch("tagsView/delCachedView", {
            name: "EditPaper",
          })
          .then((res) => {
            jump();
          });
      } else {
        jump();
      }
    },
    /**
     * 打开添加章组件
     */
    addChapter() {
      if (!this.newSujectApis.subjectId) {
        this.$message.warning("请先选择科目");
        return;
      }
      this.$refs.addChapterjs.openBoxs([this.newSujectApis]);
    },
    /**
     * 添加章-返回数据
     */
    backData(v) {
      this.$api.inquirebankexamList({ examIds: v }).then((res) => {
        this.activeLists = res.rows;
        this.submitForm();
      });
    },
    unTime(val) {
      let a = `${val.businessId}-${val.subjectId}`;
      if (this.sujectApis == a) {
        this.sujectApis = "";
      } else {
        this.sujectApis = a;
      }
    },
    changeSty(val) {
      var arr = "";
      let arr1 = this.sujectApis.split("-").map(Number);
      if (val.businessId == arr1[0] && val.subjectId == arr1[1]) {
        arr = "activeStyIcons";
      }
      return arr;
    },
    getMessage() {
      if (!this.courType) {
        this.$message.warning("请先选择业务层级");
      }
    },
    openBoxs() {
      if (!this.newSujectApis.subjectId) {
        this.$message.warning("请先选择科目");
        return;
      }
      var data = JSON.parse(JSON.stringify(this.formData));
      data.businessId = this.newSujectApis.businessId;
      data.subjectId = this.newSujectApis.subjectId;
      var self = this;
      this.$api.inquirebankexamList(data).then((res) => {
        var aList = [];
        this.tableData.map((item) => {
          aList.push(item.examId);
        });
        this.disCheckList = aList;
        this.boxtableData = res.rows;
        this.total = res.total;
        this.dialogVisible = true;
        this.$nextTick(function () {
          self.$refs.multipleTable.clearSelection();
        });
      });
    },
    getInfosList() {
      this.$api
        .inquireCoursechaptersectionlist(this.$route.query.id)
        .then((result) => {
          // this.numberAll = result.total;
          // this.minTimeAll = result.timeTotal;
          this.tableData = result.rows;
        });
    },
    getInfos(int) {
      if (int === 1) {
        this.formData.pageNum = 1;
      }
      if (int === 2) {
        this.formData = {
          publishStatus: 1,
          status: 1,
          pageSize: 10,
          pageNum: 1,
        };
      }
      var data = JSON.parse(JSON.stringify(this.formData));
      data.businessId = this.newSujectApis.businessId;
      data.subjectId = this.newSujectApis.subjectId;
      this.$api.inquirebankexamList(data).then((res) => {
        this.boxtableData = res.rows;
        this.total = res.total;
      });
    },
    init() {
      this.getInfos(2);
    },
    // search() {
    //   this.$api.obtainbankexam(this.$route.query.id).then((res) => {
    //     res.data.year = res.data.year + "";
    //     this.listData = res.data;
    //   });
    //   this.$api
    //     .inquirebankexamListbusiness({ type: 2, majorId: this.$route.query.id })
    //     .then((res) => {
    //       this.newSujectApis = res.rows[0];
    //       this.sujectApis =
    //         res.rows[0].businessId + "-" + res.rows[0].subjectId;
    //       this.getInfosList();
    //     });
    // },
    changeTypes() {
      var self = this;
      if (!this.sujectApis) {
        self.newSujectApis = {};
        return;
      }
      this.courTypeOptions.map((items) => {
        if (items.id === this.sujectApis.split("-").map(Number)[0]) {
          var obj = {
            type: 3,
            educationTypeId: items.educationId,
            educationName: items.educationName,
            projectId: items.projectId,
            projectName: items.projectName,
            businessId: items.id,
            businessName: items.businessName,
          };
          self.sujectOption.map((i) => {
            if (
              i.id === self.sujectApis.split("-").map(Number)[1] &&
              i.courseArrays.indexOf(items.projectId) !== -1
            ) {
              obj.subjectName = i.subjectName;
              obj.subjectId = i.id;
            }
          });
          self.newSujectApis = obj;
        }
      });
    },
    submitSujectArray() {
      this.$refs.popovers.doClose();
    },
    showHandle() {
      this.sujectApis = "";
      this.newSujectOption.map((item) => {
        item.newId = this.courType + "-" + item.id;
        if (item.newId === this.sujectApis) {
          console.log("成功");
        }
      });
      this.sujectApis =
        this.newSujectApis.businessId + "-" + this.newSujectApis.subjectId;
    },
    hideHandle() {},
    getDict() {
      this.$api.inquireCourseEducationType({ status: 1 }).then((res) => {
        this.eduTypeOptions = res.rows;
      });
      this.$api.inquireCourseProjectType({ status: 1 }).then((res) => {
        this.projectTypeOptions = res.rows;
      });
      this.$api.inquirebusinessList({ status: 1 }).then((res) => {
        this.courTypeOptions = res.rows;
        this.newCourTypeOptions = res.rows;
      });
      this.$api.inquireCourseSubject({ status: 1 }).then((res) => {
        res.rows.map((item, index) => {
          var array = [];
          item.courseProjectTypes.map((items, indexs) => {
            array.push(items.id);
          });
          item.courseArrays = array;
        });
        this.sujectOption = res.rows;
      });
    },
    changeEduType() {
      if (!(this.courType === undefined || this.courType === "")) {
        this.courType = "";
      }
      var arrays = [];
      this.courTypeOptions.map((item) => {
        if (item.educationId === this.eduType) {
          arrays.push(item);
        }
      });
      this.newCourTypeOptions = arrays;
    },
    changecourseType() {
      this.newCourTypeOptions.map((item, index) => {
        if (item.id === this.courType) {
          this.eduType = item.educationId;
          var array = [];
          this.sujectOption.map((items, indexs) => {
            if (items.courseArrays.indexOf(item.projectId) !== -1) {
              array.push(items);
            }
          });
          this.newSujectOption = array;
        }
      });
      var arrays = [];
      this.courTypeOptions.map((item) => {
        if (item.educationId === this.eduType) {
          arrays.push(item);
        }
      });
      this.newCourTypeOptions = arrays;
      this.$refs.popovers.doClose();
      this.tableData = [];
    },
    submitIns(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          if (JSON.stringify(this.newSujectApis) === "{}") {
            this.$message.error("请选择适用业务层级");
            return;
          }
          for (let i = 0; i < this.tableData.length; i++) {
            if (!this.tableData[i].sort && this.tableData[i].sort !== 0) {
              this.$message.warning(`管理试卷第${i + 1}条请输入排序`);
              return;
            }
          }
          let arr = this.tableData.map((items) => {
            return items.sort;
          });
          if (new Set(arr).size != arr.length) {
            this.$message.warning("排序不允许有重复值");
            return;
          }
          this.rulesTableSumbit();
        } else {
          return false;
        }
      });
    },
    async rulesTableSumbit() {
      this.disabledBtn = true;
      var examList = [];
      this.tableData.map((item) => {
        examList.push({ examId: item.examId, sort: Number(item.sort) });
      });
      var data1 = {
        // examId: this.listData.examId,
        name: this.listData.name,
        examList: examList,
        publishStatus: this.listData.publishStatus,
        prefixName: this.listData.prefixName,
        businessList: [this.newSujectApis],
        year: this.listData.year,
        status: 1,
      };
      this.$api
        .addbankchapter(data1)
        .then((res) => {
          this.$methodsTools.cacheBusinessList([this.newSujectApis]);
          this.$message.success("新增成功");
          setTimeout(() => {
            this.$store
              .dispatch("tagsView/exitView", this.$route)
              .then((res) => {
                this.$router.push({
                  path: "chapterVolumeManagement",
                });
              });
          }, 500);
        })
        .catch(() => {
          this.disabledBtn = false;
        });
    },
    backPage() {
      this.$store.dispatch("tagsView/delView", this.$route).then((res) => {
        this.$router.push({
          path: "chapterVolumeManagement",
        });
      });
    },
    closeType() {
      this.sujectApis = "";
    },
    handleSizeChange(v) {
      this.formData.pageSize = v;
      this.formData.pageNum = 1;
      this.getInfos();
    },
    handleCurrentChange(v) {
      this.formData.pageNum = v;
      this.getInfos();
    },
    selectAll(value) {
      this.activeLists = value;
    },
    select(value) {
      this.activeLists = value;
    },
    checkboxT(row, index) {
      if (this.disCheckList.indexOf(row.examId) !== -1) {
        return false;
      } else {
        return true;
      }
    },
    getRowKeys(row) {
      return row.examId;
    },
    submitForm() {
      if (this.activeLists.length === 0) {
        this.dialogVisible = false;
        return;
      }
      if (this.tableData.length) {
        let maxIndex = 0;
        this.tableData.forEach((item) => {
          if (item.sort > maxIndex) {
            maxIndex = item.sort;
          }
        });
        this.activeLists.forEach((item, index) => {
          item.sort = maxIndex + index + 1;
        });
      } else {
        this.activeLists.forEach((item, index) => {
          item.sort = index + 1;
        });
      }
      this.tableData = this.tableData.concat(this.activeLists);
      this.dialogVisible = false;
      this.$message.success("添加成功");
    },
    delList(item, index) {
      this.tableData.splice(index, 1);
      this.$message.success("删除成功");
    },
    closedFunc() {
      this.activeLists = [];
    },
  },
};
</script>

<style lang="less" scoped>
.dis_flexbox {
  display: flex;
  flex-direction: column;
}
.boxWidth {
  width: 700px;
}
.numInputs {
  width: 150px;
}
.checkboxSty {
  max-height: 210px;
  overflow: auto;
  display: flex;
  flex-direction: column;
}
.listBoxStys {
  flex-shrink: 0;
  padding: 0px 10px;
  border-radius: 8px;
  border: 1px solid #eee;
  margin-right: 10px;
  margin-bottom: 6px;
}
.closeIcons {
  color: red;
  cursor: pointer;
  margin-left: 6px;
}
.ach {
  display: flex;
  align-items: center;
  overflow: hidden;
}
.clh {
  display: flex;
  align-items: center;
  flex-wrap: wrap;
}
.imgBoxins {
  width: 375px;
  height: 220px;
  text-align: center;
  img {
    height: 100%;
  }
}
.iconStsz {
  font-size: 40px;
  color: #67c23a;
  cursor: pointer;
}
.BusBoxs {
  min-height: 100px;
  border: 1px solid #a4a4a4;
  margin-bottom: 10px;
  border-radius: 8px;
  max-height: 280px;
  padding: 10px;
  overflow-y: auto;
  .fot_Le {
    border-radius: 12px;
    border: 1px solid yellowgreen;
    padding: 0px 10px;
    height: 30px;
    line-height: 30px;
    text-align: center;
    float: left;
    margin-right: 6px;
    margin-bottom: 6px;
    .icon_clear {
      margin-left: 2px;
      font-size: 15px;
      color: #f56c6c;
      cursor: pointer;
    }
  }
}
.marg_play {
  display: flex;
  margin-bottom: 15px;
  .spans {
    text-align: right;
    width: 80px;
  }
}
/deep/.el-button {
  border-radius: 8px;
}
/deep/.el-dialog {
  border-radius: 8px;
  .el-dialog__header {
    padding: 0;
    .hearders {
      height: 40px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0px 18px 0px 20px;
      border-bottom: 1px solid #e2e2e2;
      .leftTitle {
        font-size: 14px;
        font-weight: bold;
        color: #2f4378;
      }
      .rightBoxs {
        display: flex;
        align-items: center;
        img {
          width: 14px;
          height: 14px;
          margin-left: 13px;
          cursor: pointer;
        }
      }
    }
  }
  .el-dialog__footer {
    padding: 0;
    .dialog-footer {
      padding: 0px 40px;
      height: 70px;
      border-top: 1px solid #e2e2e2;
      display: flex;
      align-items: center;
      justify-content: center;
    }
  }
}
.centerStys {
  display: flex;
  align-items: center;
  justify-content: center;
  margin-top: 18px;
}
.dis_fos {
  align-items: flex-end;
  display: flex;
  justify-content: space-between;
}
.margin_bs {
  margin-bottom: 6px;
}
.dis_plays {
  display: flex;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 10px;
}
.comInputsty {
  width: 50px;
  height: 24px;
  text-align: center;
  border: none;
}
</style>
